from OpenGL.GL import *;
from OpenGL.GLU import *;
from pygame.locals import *;
import pygame;
from common import *;
import font;
import ac3d;
import smoke;
import flame;

#change font to the game.font thing
#add game or re class for this;

class MenuItem:
	def __init__(self, text, fnt ):
		self.text = text;
		#self.width = len(text)*10.0;
		self.width = 80;
		self.height = 15.0;
		self.center = Vertex( );
		self.active = 0;
		self.font = fnt;
		
	def isInside(self, x, y ):
		left = self.center.x - self.width/2.0;
		right = self.center.x + self.width/2.0;
		top = self.center.y - self.height/2.0;
		bottom = self.center.y + self.height/2.0;

		if( x < right and x > left ):
			if( y > bottom and y < top ):
				return 1;
			else: 
				return 0;
		else:
			return 0;

	def setCenter(self, x, y, z ):
		self.center.x = x;
		self.center.y = y;
		self.center.z = z;
		
	def setActive(self, value = 1):
		self.active = value;

	def render(self):
		left = self.center.x - self.width/2.0;
		right = self.center.x + self.width/2.0;
		top = self.center.y - self.height/2.0;
		bottom = self.center.y + self.height/2.0;
		
#		#print  left, right, top, bottom ;
		glDisable(GL_TEXTURE_2D);
		if(self.active):
			glColor4f( .5, .4, .1, .5 );
			glEnable( GL_ALPHA_TEST );
			glBegin( GL_POLYGON );
			glVertex3f( left, top, self.center.z );
			glVertex3f( left, bottom, self.center.z );
			glVertex3f( right, bottom, self.center.z );
			glVertex3f( right, top, self.center.z );
			glEnd();
			glDisable( GL_ALPHA_TEST );

		glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
		glColor4f( .5, .4, .1, 1 );
		glBegin( GL_POLYGON );
		glVertex3f( left, top, self.center.z );
		glVertex3f( left, bottom, self.center.z );
		glVertex3f( right, bottom, self.center.z );
		glVertex3f( right, top, self.center.z );
		glEnd();
		glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
		glEnable( GL_TEXTURE_2D );
		self.font.drawString( self.text, left, top+12,  10, 10 );

class MenuPage:
	def __init__(self, font, model, v=["None", "None", "None", "None"] ):
		self.items= [];
		self.font ="";
		self.curid = 0;
		self.done = 0;
		self.font = font; #font.Font("textures/Font.tga");
		self.model = model;
		self.flame = flame.Flame( -50, 0, 20, 20); 
		self.mpageText = [ ];
		self.fontsize = 10;
		#self.model.loc.x = 40;
		#self.model.loc.z = 00

		for i in xrange(len(v)):
			item = MenuItem (v[i],self.font);
			item.center.x = 0;
			item.center.y = 30-i*(item.height+10);
			item.center.z = 0;
			self.items.append(item); 
			
	def animate(self):
		self.flame.animate( );
	#	self.model.animate(0.05);

	#render all the menu items in this menu page
	def render(self):
		#set the cur item active
		self.items[self.curid].setActive( );
		view2D( );
		glDisable(GL_LIGHTING);
		glColor3f(1, 1, 1 );
		glBindTexture( GL_TEXTURE_2D, self.model );
		glBegin(GL_POLYGON);
		glTexCoord2f(0,0);glVertex3f( -133, -100, -10 );
		glTexCoord2f(1,0);glVertex3f( 133, -100, -10 );
		glTexCoord2f(1,1);glVertex3f( 133, 100, -10 );
		glTexCoord2f(0,1);glVertex3f( -133, 100, -10 );
		glEnd( );


		for i in xrange(len(self.mpageText)):
		    self.font.drawString( self.mpageText[i], -130, 80-i*self.fontsize, self.fontsize, self.fontsize );
		    
		glPushMatrix();
		glTranslatef(-60, self.items[self.curid].center.y, 0);
		glRotatef( -90, 0, 0, 1 );
		self.flame.render( );
		glPopMatrix();	
		

		for item in self.items:
			item.render( );
			item.setActive(0);
		glEnable(GL_LIGHTING);
			
	def keyEvents(self, event):
		#manage the key input
		if event.type is KEYDOWN:
			if event.key == K_UP:
				self.curid = (self.curid-1)%len(self.items);		
			if event.key == K_DOWN:
				self.curid = (self.curid+1)%len(self.items);		
			if event.key == K_RETURN:
				#activate the menu item
				#self.done = 1;
				#if self.items[self.curid].text == 'EXIT':
				#	self.quit = 1;
				return self.items[self.curid].text;

		#manage mouse events
		elif event.type is MOUSEBUTTONDOWN:
			for i in xrange(len(self.items)):
				mx, my = pygame.mouse.get_pos( );
				if self.items[i].isInside( mx, my ) == 1:
					self.curid = i;	
