from OpenGL.GL import *;
from OpenGL.GLU import *;
from OpenGL.GLUT import *;
import common;
import flame;
import smoke;
import sys;
import math;

class gameObject:
	center = [ 0, 0, 0 ];
	velocity = [ 0, 0, 0 ];
	type = "tree";
	culled = False;
	health = 120.0;
	radius = 50;
	height = 50;
	width=50;
	length=50;
	rotAngle = 0;
	rotAngleZ = 0;
	range = 200;
	shoot_interval = 0;
#	normal=[];
#	bbox = [ [-50,0,0], [0,-50,0], [0,0,-50], [50,0,0], [0,50,0], [0,0,50], [0,0,0], [0,0,0] ];
	def __init__(self, center=[0,0,0], velocity=[0,0,0], type ="tree" ):
		self.center = center;
		self.velocity = velocity;
		self.type = type;
		self.flame = flame.Flame( center[0], center[1], center[2] ); 
		#self.smoke = smoke.Smoke( center[0], center[1], center[2], 0, 40, 0, 5, .4, common.Global_smokeTex );

	def animate(self):
		self.center[0] += self.velocity[0];
		self.center[1] += self.velocity[1];
		self.center[2] += self.velocity[2];	
		if( self.center[1] <= -self.height+10 and self.health <= 10 ):
		    self.velocity = [ 0, 0, 0 ];
		    #self.health = -1;

		#add the rockets only if the object is alive
		if( self.health > 40 ):
			if self.type == "air":
			    distance = math.sqrt(self.center[0]*self.center[0]+self.center[2]*self.center[2]);
			    if distance <= self.range :
				velvec = [ -6*self.center[0]/distance, -6*self.center[1]/distance, -6*self.center[2]/distance ];
				if self.type == "air" and self.shoot_interval == 0:
				    newobj = gameObject( [self.center[0], self.center[1], self.center[2]], velvec, "rocket" );
				    #newobj.rotAngle =self.rotAngle; 
				    newobj.rotAngleZ = 90;
				    common.Global_objMovArray.append(newobj);
				    self.shoot_interval = 1;

			if self.type == "land":
			    #distance = math.sqrt(self.center[0]*self.center[0]+self.center[1]*self.center[1]+self.center[2]*self.center[2]);
			    distance = math.sqrt(self.center[0]*self.center[0]+self.center[2]*self.center[2]);
			    #if the target is in range, then stop and start firing.
			    if distance <= self.range :
			        self.velocity = [ 0, 0, 0 ];
			        self.shoot_interval += 1;
        
			    if self.shoot_interval == 15:
				velvec = [ -20*self.center[0]/distance, -20*self.center[1]/distance, -20*self.center[2]/distance ];
				newobj = gameObject( [self.center[0], self.center[1]+1.1*self.height, self.center[2]], velvec, "rocket" );
				newobj.rotAngle =self.rotAngle; 
				common.Global_objMovArray.append(newobj);
				self.shoot_interval = 0;
		    
		if self.health <= 40 and self.health >= 0:
			self.health -= 1;
			#self.smoke.animate( 0.05 );
			self.flame.animate( );
			#change the center of smoke to obj center
			#self.smoke.ox = self.center[0];
			#self.smoke.oy = self.center[1]+self.height/2.0;
			#self.smoke.oz = self.center[2];
			#change only the y direction.
			#self.smoke.dy = self.smoke.oy+40;
    
			#change the center of flame
			self.flame.x = self.center[0];
			self.flame.y = self.center[1]+self.height/2.0;
			self.flame.z = self.center[2];

	
	def isInside(self, point):
#		bbox = [ [-50,0,0], [0,-50,0], [0,0,-50], [50,0,0], [0,50,0], [0,0,50], [0,0,0], [0,0,0] ];
#		bbox[0][0] = bbox[1][0] = - self.width/2.0;
#		bbox[2][0] = bbox[3][0] = - self.width/2.0;
#		bbox[4][0] = bbox[5][0] = + self.width/2.0;
#		bbox[6][0] = bbox[7][0] = + self.width/2.0;

#		bbox[2][1] = bbox[3][1] = - self.height/2.0;
#		bbox[6][1] = bbox[7][1] = - self.height/2.0;
#		bbox[0][1] = bbox[1][1] = + self.height/2.0;
#		bbox[4][1] = bbox[5][1] = + self.height/2.0;

#		bbox[0][2] = bbox[2][2] = - self.length;
#		bbox[4][2] = bbox[6][2] = - self.length;
#		bbox[1][2] = bbox[3][2] = + self.length;
#		bbox[5][2] = bbox[7][2] = + self.length;

		count = 0;
#		for i in xrange(len(point)):
#			if point[i] >= self.center[i]-self.radius and point[i] <= self.center[i]+self.radius:
#				count+=1;
		#x in range
		if point[0] >= self.center[0]-self.width/2.0 and point[0] <= self.center[0]+self.width/2.0:
			#y in range
			if point[1] >= self.center[1] and point[1] <= self.center[1]+self.height:
				#z in range
				if point[2] >= self.center[2]-self.length/2.0 and point[2] <= self.center[2]+self.length/2.0:
				    return True;
		return False;
				
	def render(self):
	
#		if self.type == "rocket":
#			glPushMatrix( );
#			glTranslatef( self.center[0], self.center[1], self.center[2] );
#			glColor3f( 1, 1, 1 );
#			glutSolidSphere( 5, 4, 4 );
#			glPopMatrix( );
#			return;
		if self.type == "flareammo"  or self.type == "rocketammo":
		    glPushMatrix( );
		    glColor3f( 1, 1, 1 );
		    glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, [1,1,1,1] );
		    glTranslatef( self.center[0], self.center[1], self.center[2] );
		    common.viewSprite( );
		    glBindTexture( GL_TEXTURE_2D, common.Global_flareAmmoTex );
		    if( self.type == "flare" ):
			glBindTexture( GL_TEXTURE_2D, common.Global_blueflareTex )
		    elif( self.type == "rocketammo" ):
			glBindTexture( GL_TEXTURE_2D, common.Global_rocketAmmoTex )
		    glBegin(GL_POLYGON)
		    glTexCoord2f( 0, 0 ); glVertex3f( -10, 0, 0);
		    glTexCoord2f( 1, 0 ); glVertex3f( 10, 0, 0);
		    glTexCoord2f( 1, 1 ); glVertex3f( 10, 20, 0 );
		    glTexCoord2f( 0, 1 ); glVertex3f( -10, 20, 0 );
		    glEnd( )
		    glPopMatrix( );

		elif self.type == "flare":
		    glPushMatrix( );
		    glColor3f( 1, 1, 1 );
		    glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, [1,1,1,1] );
		    glTranslatef( self.center[0], self.center[1], self.center[2] );
		    common.viewSprite( );
		    glBindTexture( GL_TEXTURE_2D, common.Global_blueflareTex )
		    glBegin(GL_POLYGON)
		    glTexCoord2f( 0, 0 ); glVertex3f( -10, -10, 0);
		    glTexCoord2f( 1, 0 ); glVertex3f( 10, -10, 0);
		    glTexCoord2f( 1, 1 ); glVertex3f( 10, 10, 0 );
		    glTexCoord2f( 0, 1 ); glVertex3f( -10, 10, 0 );
		    glEnd( )
		    glPopMatrix( );

		else:
		        model = common.Global_ModelArray[self.type];
			if self.health <= 40 and self.health >= 0:
			    glColor3f( 1, 1, 1 );
			    glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, [1,1,1,1] );
			    glPushMatrix( );
			    glTranslatef( self.flame.x, self.flame.y, self.flame.z );
			    common.viewSprite( );
			    smoke.Global_SmokeVar.render( );
			    #self.smoke.render( );
			    self.flame.render( );glPopMatrix();
			color = self.health/100.0;
			if self.type == "pplant":
			    color = self.health/500.0;
			if color <= 0.1:
			    color = 0.1;
			glMaterialfv( GL_FRONT, GL_AMBIENT, [color, color, color, 1.0 ]);
			glPushMatrix( );
			glTranslatef( self.center[0], self.center[1], self.center[2] );
			if self.rotAngleZ == 0: 
			    glRotatef( self.rotAngle, 0, 1, 0 );
			else:
			    glRotatef( 90, 1, 0, 0 );
			model.render( );
			glPopMatrix( );
			
			if self.type == "tree" and self.health >= 10:
				tmp = common.Global_ModelArray['leaves'];
				tmp.loc.x = self.center[0];
				tmp.loc.y = self.center[1];
				tmp.loc.z = self.center[2];
				tmp.render( );
				
        
